Howto display error message instantly when command fails
While writing a shell script you may need to display an error message. For example if you failed to open /etc/passwd file you want to display error message.
Old way
You can write something as follows:
cat /etc/shadow 2>/dev/null
if [ $? -ne 0 ]; then echo "Failed to open file"; exit1 ; fi
New way - OR || control operator
However you can use control operator || (or lists). It has the form:
command1 || command2
command2 is executed if and only if command1 returns a non-zero exit status. For example:
$ cat /etc/shadow 2>/dev/null || echo “Failed to open file”
This way you display error message. Another option is to create die function:
#!/bin/bash
function die(){
echo $1
exit 1
}
# ...
# ... other code
cat /etc/shadow 2>/dev/null || die “Failed to open file”
# rest of script
AND && control operator
Similarly you can use AND (&&) control operator. It has the form:
command1 && command2
command2 is executed if, and only if, command1 returns an exit status of zero.
$ cat /etc/shadow 2>/dev/null && echo "I can open /etc/shadow file"
You can combine both to produce useful message in a script:
#!/bin/bash
...
tar -zcf /dev/st0 /data2 && echo "/data2 added to backup device" || echo "Warning: Cannot add /data2 to backup device"
....
E-mail this to a friend
Printable version
You may also be interested in other helpful articles:
- PHP Log All Errors to a Log File to Get Detailed Information
- Search Linux / UNIX log files smartly for an alert or warning error
- FreeBSD > Displaying System-Specific Messages at Login
- Quick tip: Easily find strings with grep color highlighting feature
- Linux mail server: How to fight image spam
Leave a Reply
We encourage your comments, and suggestions. But please stay on topic, be polite, and avoid spam. Thank you very much for stopping by our site!



Recent Comments
Yesterday ~ 21 Comments
Yesterday ~ 15 Comments
Yesterday ~ 10 Comments
Yesterday ~ 15 Comments
Yesterday ~ 18 Comments